/*
======================================================================


www.Steelronin.com
Scott@steelronin.com  
======================================================================
*/

scriptName = "SR_Rename v0.1.0";
copyright = "Copyright (c) 2004 Scott lange";

/*
version notes
*/ 

@version 2.3
@warnings
@name SR_Rename
@script generic

generic
{
	sel = Scene().getSelect();
	return if(!sel);
    
    // reverse sel order
    selcopy = sel;
    for(a=1;a<=size(selcopy);a++)
        sel[(size(selcopy)+1) - a]=selcopy[a];
        
	reType = 1;
	newName = "";
	oldName = "";
	
	reqbegin("SR Rename");
	c1 = ctlpopup("Rename Type", reType , @"Rename","Replace Prefix","Replace Suffix","Replace","Incrimental Number"@);
	c2 = ctlstring("Old Name", oldName);
	c3 = ctlstring("New Name", newName);
	ctlactive(c1,"active_c3",c2);
	return if !reqpost();
    
    reType = getvalue(c1);
	oldName = getvalue(c2);
	newName = getvalue(c3);
    
    reqend();

	if(reType==1){ //Rename
		for(i=1;i<=sel.size();i++){
			SelectItem(sel[i].id);
			Rename(newName);
		}
	}
	else if(reType==2){ //Replace Prefix
		l = oldName.size();
		for(i=1;i<=sel.size();i++){
			itemName = removeNum(sel[i].name);
			if(strleft(itemName,l)==oldName){
				SelectItem(sel[i].id);
				itemName = string(newName, strright(itemName, itemName.size() - l));
				Rename(itemName);
			}
		}
	}
	else if(reType==3){ //Replace Ending
		l = oldName.size();
		for(i=1;i<=sel.size();i++){
			itemName = removeNum(sel[i].name);
			if(strright(itemName,l)==oldName){
				SelectItem(sel[i].id);
				itemName = string(strleft(itemName, itemName.size() - l) , newName);
				Rename(itemName);
			}
		}
	}
	else if(reType==4){ //Replace Containes
		l = oldName.size();
		for(i=1;i<=sel.size();i++){
			itemName = removeNum(sel[i].name);
			poss = itemName.size() - l + 1;
			for(j=1;j<=poss;j++){
				if(strsub(itemName,j,l)==oldName){
					SelectItem(sel[i].id);
					itemName = string(strleft(itemName, j - 1) , newName, strright(itemName,itemName.size() - j - l + 1));
					Rename(itemName);
					break;
				}
			}
		}
	}
	else if(reType==5){ //Incrimental Number
		nDigits = floor(log(sel.size()));
		for(i=1;i<=sel.size();i++){
			SelectItem(sel[i].id);
			Rename(string(newName,strright(string(10000 + i),nDigits)));
		}
	}
	
	oldSelection(sel);
}

removeNum: nme
{
	if(strright(nme,1)==")"){
		let = strright(nme,3);
		j = 4;
		while(strleft(let,1)!="("){
			let = strright(nme,j);
			j++;
			if(j>10) break;
		}
		nme = strleft(nme , nme.size() - let.size() - 1);
	}
	return(nme);
}

oldSelection: sel
{
	//select the original selection
	SelectItem(sel[1].id);
	if(sel.size()>1)
		for(i=2;i<=sel.size();i++)
			AddToSelection(sel[i].id);
}

active_c3: value
{
	return(value > 1 && value < 5);
}